#!/usr/bin/perl

use warnings;
use strict;
use Cwd qw(abs_path);
use File::Basename;

#perl2exe_include PerlIO
#perl2exe_include Encode



my $remvrtxt = 'remdir.txt';



my $debug = ''; 			   
my $debugfile='debug.txt';
my $dbug;
#my $remvrtxt = ''; 

my $path;
my $arg0;
my $line;
my $remvr;
my $ver;
my $launchscript;
my $script = "$0"; 
if ($debugfile) { open($dbug, '>', $debugfile); }
if ($debugfile) {print $dbug "\$0 =$0\n";} 

if ($script=~ m|((?=\w+\.\w{2,3}$).+)|){
$launchscript = $1;
}

if ($remvrtxt) {
    $path = abs_path($0);
	$path =~ tr|\\|/|;
    if ($debugfile){ print $dbug "abs_path(\$0) \=$path\n" ;} 	   				 	   		 						   	  															 
    if ( $path =~ m|(.*)($launchscript)$| ) {
        $path = $1;

        if ($debug) { print "Rem version txt file located at $path \n"; }
		if ($debugfile) { print $dbug "Rem version lookup txt file located at =$path\n";}		
    }
    $remvr = "$path$remvrtxt";
    $arg0  = "$ARGV[0]";
	if ($debugfile) {  print $dbug "\$remvrtxt  =$remvrtxt\n";}
	if ($debugfile) {  print $dbug "\$remvr  =$remvr\n";}
    if ($debug) { print "REM file trying to be opened is at \n$arg0 \n"; }
	if ($debugfile) { print $dbug "REM file trying to be opened is at \n$arg0 \n";}
}
else {
    $remvr =
      'C:/Users/Public/Architectural Energy Corporation/RemLaunch/remdir.txt'
      ;    
    $arg0 =
'C:\Users\Glenn\ownCloud\Ratings\Fallon\0030-0262-P1_TBD_13 Nereid Place_CODE_HERS.blg'
      ;    
}

$arg0 =~ s/\\/\//g
  ; 
my $fname = "$arg0"
  ;  

if ($debug) { print "Rem file path fixed forward slashes to $fname \n"; }

open( my $fh, '<:encoding(UTF-8)', $fname )
  or die("Can't open REMRate building file \"$fname\":$!\n");
my @lines = <$fh>;

close($fh);

if ($debug) { print "Rem file line 3 or \$lines[2] =$lines[2] \n"; }
if ($debugfile) { print $dbug "Rem file line 3 AKA \$lines[2] =$lines[2] \n"; }

$line = $lines[2];

if ($debug) { print "Rem file \$line =$line \n"; }

chomp($line);         
$line =~ s/\s+$//;    

if ( $line =~ /(\S+)$/ )
{ 
    $ver = "$1";
    if ($debug) { print "Rem ver found \$ver set to =$ver \n"; }
	if ($debugfile) {  print $dbug "Rem ver found \$ver set to =$ver \n"; }
}

if ($debug) { print "Rem file version is =$ver \n"; }
open( my $remvrfh, '<:encoding(UTF-8)', $remvr )
  or die("Can't open input rem version file \"$remvr\":$!\n");
close($remvr);
while ( my $vrline = <$remvrfh> ) {
    chomp($vrline);
    ( my $word1, my $word2 ) = split /=/,
      $vrline; 

    if ( $word1 eq $ver ) {
        $word2 =~ s/\\/\//g
          ;

        if ($debug) { print "Found in lookup file a match to the bld file $word1=$word2  \n"; }
        if ($debugfile) {  print $dbug "Found in lookup file a match to the bld file $word1=$word2  \n"; }
        $word2 =~ tr{/}{\\};
        $fname =~ tr{/}{\\};
        my $mylaunch = "START \"\" \"$word2\" \"$fname\"";
		if ($debugfile) {  print $dbug "\$mylaunch is =$mylaunch  \n"; 
		close $dbug;
		}
        if ($debug) {
            print "$mylaunch \n";
            print "Shall we launch REMRate? \n";
            chomp( my $choice = <STDIN> );

            if ( $choice eq "n|no" ) { exit; }
        }
        {                    
            exec("$mylaunch");
        }
        last;

    }
}

